// Waiting Game
// by unnamed007
// v0.3.2
//
// Inspired by ptdw's "The Guillotine". Using his shock sounds.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
// This copyright refers only to this script itself; it does not include any other included resources
// (images, music, sounds, etc.) which remain the property of their owners.

setInfos(8, "Waiting Game", "An e-stim based psychological and physical torture session.", "unnamed007", "v0.3.2", 0xDDDDDD, "en", ["pain", "estim", "bondage", "formale", "forfemale", "psychological"]);

// Check for estim device.
if(loadBoolean("toys.estim") == false) {
	show("An estim device is required to get the full experience in this script.\n \n If you have one, access Options->Toys and tick the box. \n \n You will need to restart.")
	wait (10)
	exit()
}

def shocksToGet = 2;
def shocksGot = 0;
def shocksMissed = 0;
def dialogArray
def dialog = "";
def main_Pics = 6; 
def levelTwo_Pics = 5;
def levelThree_Pics = 5;
def checkingLevel = true;
def tempWaitTime = 0;
def waitTime = 0;
def guaranteedShock = 1;
def menu = 0;
def timerTemp = 0;
def infoMenuVar = false;
def name = loadString("intro.name");
def timeLeft = 0;
if (name == null) { name = "man"; }
def tutNot = true;

def model = loadString("waitinggame.model");
if (model == null) { model = "n"; }

def timeShow = loadBoolean("waitinggame.timeshow");
if (timeShow == null) { timeShow = false; }

def runTime = loadInteger("waitinggame.runtime");
if (runTime == null) { runTime = 10; }

def loadGuaranteedShock = loadInteger("waitinggame.guaranteedShock"); 
if (loadGuaranteedShock == null) { guaranteedShock = 1; }

def prefShocksToGet = loadInteger("waitinggame.shocksToGet");
if (prefShocksToGet == null) { prefShocksToGet = 30; }

def shockRoll = {
	if (getRandom(9) == 0) {
		def rdm = getRandom(99);
		switch (rdm) {
			case 0..10: 
				playSound("waitinggame/gamepulse_long.wav");
				shocksGot++;
				shocksMissed = 0;
				break;
			case 11..20:
				playSound("waitinggame/gamepulse.wav");
				shocksGot++;
				shocksMissed = 0;
				break;
			case 21..40:
				playSound("waitinggame/gamepulse_long_low.wav");
				shocksGot++;
				shocksMissed = 0;
				break;
			case 41..100:
				playSound("waitinggame/gamepulse_low.wav");
				shocksGot++
				shocksMissed = 0;
				break;
		
		playSound("waitinggame/gamepulse.wav");
		shocksGot++;
		shocksMissed = 0;
		}
	}
	else {
	shocksMissed++;
	}
	if (shocksMissed == 25)
	{
//		showPopup("RNG Fix Triggered  " + shocksMissed);
		if (getRandom(2) == 0) {
		playSound("waitinggame/gamepulse_low.wav");
		shocksGot++;
		shocksMissed = 0;
		}
	}
}

def saveStats = {
	def tempSessions = loadInteger("waitinggame.sessions"); 
	if (tempSessions == null) { save("waitinggame.sessions", 1); }
	else if (tempSessions != null) { save("waitinggame.sessions", (tempSessions + 1)); }
	
	def tempShocks = loadInteger("waitinggame.shocksGot"); 
	if (tempShocks == null) { save("waitinggame.shocksGot", shocksGot); }
	else if (tempShocks != null) { save("waitinggame.shocksGot", (tempShocks + shocksGot)); }
	
	def tempSecondsWaited = loadInteger("waitinggame.secondsWaited");
	if (tempSecondsWaited == null) { save("waitinggame.secondsWaited", waitTime); }
	else if (tempSecondsWaited != null) {save("waitinggame.secondsWaited", tempSecondsWaited + waitTime); }
}

def gameEnd = {
	saveStats()
	if (model == "v") { setImage("waitinggame/vintro3.jpg") }	
	if (model == "n") { setImage("waitinggame/nintro3.jpg") }	
	show("It's been quite an interesting experience. \n\n For both of us, I hope.")
	wait(5)
	show("You've waited for the shock for a total of " + (Math.round(waitTime/60)) + " minutes"
	+ "\n\n You've received the shock " + shocksGot + " times.")
	showButton("Continue")
	show("I've had fun, and I hope you did too. Be sure to drop by soon and we'll do it again.")
	wait (3)
	exit()
}

def setMainImage = {
	if (model == "v")
	{
		def imageNumber = getRandom(main_Pics)+1
		setImage("waitinggame/vmain_"+imageNumber+".jpg")
	}
	else 
	{
		def imageNumber = getRandom(main_Pics)+1
		setImage("waitinggame/nmain_"+imageNumber+".jpg")
	}
}

def setLevelTwoImage = {
	if (model == "v")
	{
		def imageNumber = getRandom(levelTwo_Pics)+1
		setImage("waitinggame/vlvl2_"+imageNumber+".jpg")
	}
	else 
	{
		def imageNumber = getRandom(levelTwo_Pics)+1
		setImage("waitinggame/nlvl2_"+imageNumber+".jpg")
	}
}

def setLevelThreeImage = {
	if (model == "v")
	{
		def imageNumber = getRandom(levelThree_Pics)+1
		setImage("waitinggame/vlvl3_"+imageNumber+".jpg")
	}
	else 
	{
		def imageNumber = getRandom(levelThree_Pics)+1
		setImage("waitinggame/nlvl3_"+imageNumber+".jpg")
	}
}

def shockSession = {
while (timeLeft > 0) {
	if (shocksGot <= 10) {
		setMainImage()
		dialogArray = ["How are you holding up, "+name+"? We're just begining, I'd hate for you to be.. uncomfortable.",
		"Is the shock the worst part of this? \n The high intensity but relatively small duration.",
		"Is the wait the worst part of it? \n Not knowing when the next one will come.",
		"The wait, or the shock. I want you to have both, "+name+". One right after the other.",
		"And the best part is I can keep this up for a very long time.",
		"But how long will you be able to last? \n How long until you are driven mad?",
		"The look on your face when the shock hits, it's just priceless. I want to see it more. More!",
		"First there's the anticipation, then the pain, then even more anticipation, and then...",
		"And release is so far away, how many hours until I finally grant mercy? How many days?",
		"And all you can do is wait, and wait, and eventually..",
		"Eventually the shock will be applied, when you least expect it.",
		"This will go on until I am satisfied. \n And I am famously hard to satisfy.",
		"How many shocks have you received so far? \n Did you even try to keep count?",
		"How many shocks left until I stop, how many more can you take "+name+"?",
		"This is quite amusing. \n Looking at you as you struggle and wiggle."]
		if (timeShow) { dialog = dialogArray[getRandom(dialogArray.size)] + "\n \n Time left: " + (Math.round(timeLeft/60)) + " minutes." }
		else { dialog = dialogArray[getRandom(dialogArray.size)] } 
		show(dialog)
		tempWaitTime = (getRandom(30) + 2);
		waitTime += tempWaitTime;
		wait(tempWaitTime);
		timeLeft = timeLeft - tempWaitTime;
		shockRoll()
		}
	else if (shocksGot <= 20) {
		setLevelTwoImage()
		dialogArray = ["Hey, "+name+"! Is it getting warm in here, or is it just me?",
		"Room must be getting warm from all your sweating and panting.",
		"Calm down, take it easy. There's nothing to be afraid of. Apart from the shock that is.",
		"I'm just going to slip out of some of my clothes, add a third layer of torture to this.",
		"Do you like what you see? Focus on my body. Forget about the shock, until...",
		"I think begining to undress might make this worse for you, so then it's good for me.",
		"Are you enjoying the show? Look here. Forget about everything else..",
		"Yeah, I think this is working. I'll keep doing it, you just stay there and keep getting shocked.",
		"Speaking of getting shocked. Do you know how many it's been? Have you tried keeping count?",
		"I've been peeking at her remote every now and then, I see there's another button she's not using..",
		"I've been contemplating other ways to make this worse for you, I wouldn't want you to get comfortable.",
		"I think I know what we can do to make it even worse. I'll get to it in a bit.",
		"So, about this being a bit too comfortable, to easy for you. I'll work on that soon",
		"Have you tried focusing on my body? That could make it better. Could make it worse. I'm hoping it's worse.",
		"That's it, look at me, "+name+". It's going to be so delicious seeing you get shocked right now."]
		if (timeShow) { dialog = dialogArray[getRandom(dialogArray.size)] + "\n \n Time left: " + (Math.round(timeLeft/60)) + " minutes." }
		else { dialog = dialogArray[getRandom(dialogArray.size)] } 
		show(dialog)
		tempWaitTime = (getRandom(30) + 2);
		waitTime += tempWaitTime;
		wait(tempWaitTime);
		timeLeft = timeLeft - tempWaitTime;
		shockRoll()
		}
	else if (shocksGot > 20) {
		setLevelThreeImage()
		dialogArray = ["Are you still holding up okay? We're at least half way through.",
		"There is the wait, the shock, and now me. You can look, but you can't touch.",
		"So, out of the three.. the shock, the wait, and me being naked so close? Which feels the worst "+name+"?",
		"Oh, I've just been informed there's a surprise for you coming up. Maybe you've already felt it. You'll know when you do",
		"I was thinking that you were getting too relaxed, to used to us being nice. Had to up the ante a bit. It's only fair.",
		"You can take more can't you? I mean, you kinda have to. So you will take it.",
		"What would you do to make this stop? Right now. There is nothing you can do of course, but it's nice to hope.",
		"I can see you still haven't given up on wiggling. You must've realised by now that you can't get out. Is it helping, hope?",
		"I'm sure that if you keep wiggling a bit more, you will be able to escape. Haha.",
		"I wonder, what does that button do? Let's find out. Press it, press it sister!",
		"That shiny other button has caught my eyes. Let's find out together what does it do?",
		"Listen. Look at me, do I look fine? Focus on me, that way the shock will be even more of a surprise",
		"My tits are quite the attraction. Some people get shocked when they see them. I guess you're one of those people",
		"Did you like it better when I was fully clothed? When you didn't have this to distract you too?",
		"Clothes on. Clothes off. Such a hard choice to make, I'd like you to be distracted more, but I wouldn't want you to enjoy yourself"]
		if (timeShow) { dialog = dialogArray[getRandom(dialogArray.size)] + "\n \n Time left: " + (Math.round(timeLeft/60)) + " minutes." }
		else { dialog = dialogArray[getRandom(dialogArray.size)] } 
		show(dialog)
		tempWaitTime = (getRandom(30) + 2);
		waitTime += tempWaitTime;
		wait(tempWaitTime);
		timeLeft = timeLeft - tempWaitTime;
		shockRoll()
		}
	}
	gameEnd()
}

def gameStart = {
	if (model == "v") { setImage("waitinggame/vintro4.jpg") }	
	if (model == "n") { setImage("waitinggame/nintro4.jpg") }	
	show("Alright. This is the last time you will need to click a button. The final check.")
	wait (5)
	show("You should: \n\n Have your dominant arm and both legs tied. \n\n Have your e-stim device connected. \n\n Have the intensity set to extremely high. \n\n\n If this is all true, you may continue. I recommend placing your other arm on the arm rest, as if it was tied too. \n\n If you are experienced in self-bondage, you may tie the other arm as well, as you won't be using it anymore.")
	showButton("Continue")
	if (model == "v") {
		setImage("waitinggame/vintro1.jpg") 	
		show("**You just woke up.**")
		wait(5)
		show("**You try to move, but you can't.**")
		wait(5)
		show("**The only thing you can see is a pair of legs.**")
		wait(5)
		show("**Before you can try to speak, a voice interrupts you.**")
		wait(5)
	}
	if (model == "v") { setImage("waitinggame/vintro2.jpg") }	
	if (model == "n") { setImage("waitinggame/nintro2.jpg") }	
	show("Hey! Good to see you're awake. \n We were concerned that we gave you too strong of a dose.")
	wait(5)
	show("You're tied to the chair. \n We've connected a very powerful shock device to your body.")
	wait(5)
	show("And we're going to use it well. \n We will have our revenge.")
	wait(5)
	show("You're going to sit there, \n I'm going to be talking just like I am now..")
	if (guaranteedShock == 1) { playSound("waitinggame/gamepulse_low.wav"); }
	wait(2)
	show("And just when you expect it the least. \n She will hit a button, and the pain will come.")
	wait(5)
	show("Then you will wait. How long until the next shock? I don't know. You don't know.")
	wait(5)
	show("That's what makes it fun. Fun for us anyway.")
	wait(5)
	timeLeft = runTime * 60;
	shockSession()
}

def shockCheck = {
	while (checkingLevel = true) {
		if (shocksGot >= shocksToGet) {
			wait (1)
		}
		if (tutNot)
		{
		show("There are four different shocks that will be applied randomly. \n\n The harsher ones have lower chances, but they will come, sooner or later.")
		wait(6)
		show("Here you have the opportunity to test them, or you can just set the nicer ones, and let the harsh ones be a surprise.")
		wait(6)
		tutNot = false;
		}
		def shockTest = getSelectedValue("Which shock would you like to test?",["Nice shock", "Nice shock long", "Loud shock", "Loud shock long", "Done"])
		switch(shockTest) {
			case 0: 
				playSound("waitinggame/gamepulse_low.wav");
				break;
			case 1:
				playSound("waitinggame/gamepulse_long_low.wav");
				break;
			case 2:
				playSound("waitinggame/gamepulse.wav");
				break;
			case 3:
				playSound("waitinggame/gamepulse_long.wav");
				break;
			case 4:
				checkingLevel = false;
				gameStart()
				break;
		}
	}
}

def waitingTutorial = {
	if (model == "v") { setImage("waitinggame/vintro4.jpg") }	
	if (model == "n") { setImage("waitinggame/nintro4.jpg") }	
	
	show("This is an entirely hands free experience. \n After initial setup, you will no longer have to press any buttons.")
	wait (5)
	show("However, until that is the case, you will need to do a short setup.")
	wait (5)
	show("Get your e-stim device and its electrodes. \n It needs to support audio input so that it may be activated by my files.")
	showButton("Have e-stim device ready")
	show("Connect it to your computer, and attach the electrodes to your body. \n Depending on your own anatomy and pain threshold you might want to experiment with position.")
	showButton("Continue")
	show("I recommend placing two electrodes on each inner tigh. \n This will require a device that can support four electrodes (two channels).")
	showButton("E-stim device connceted to PC and electrodes set.")
	show("Later on we will set the intensity. \n\n It needs to be hard enough that do anything to not experience it again.")
	showButton("Continue")
	show("That's where the bondage part comes in to help. \n\n I will assume that you are sitting on a chair with arms and legs.")
	showButton("Continue")
	show("A very simple (and safe) way to self-bondage is to tie your legs securely to the legs of the chair. \n\n If you have a leg-less chair, like an office chair, tie your legs together, but put the rope behind the main base of the chair.")
	showButton("Continue")
	show("Then tie your dominant hand (at the wrist) to the arm rest of the chair. \n\n For most people this means your right wrist tied to the right arm of the chair.")
	showButton("Continue")
	show("This will leave your non-dominant hand free, but that will be unlikely to be able to do anything once the shocks start. \n\n Tie yourself in that way, or if you are experienced, in your prefered self-bondage way. You will still need a free hand until we begin.")
	showButton("Everything but one hand is tied")
	shockCheck()
}

def settingsMenu = {
	def menuRunning = true;
	while (menuRunning) {
		menu = getSelectedValue	("What would you like to set?",["Set time", "Set initial shock", "Set mistress", "Set timer on/off"])
		if(menu==0) {
			def difficulty = getInteger("Amount of time you would like to play for, in minutes. \n\n I recommend ten minutes for the first playthrough.", 1)
			if (difficulty < 5) {
				show("You can't set the time to less than five minutes. \n\n Come on! Be strong.")
				runTime = 5;
				showButton("Understood.")
				}
			if (difficulty > 120) {
				show("You can't set the time to more than two hours. \n\n I must insist that you take a break after two hours.")
				showButton("Understood.")		
				runTime = 120;				
			}
			runTime = difficulty;
			show("Time was set to " + runTime + " minutes.")
			save("waitinggame.runtime", runTime)
			showButton("I understand.")
			menuRunning = false;
		}
		if(menu==1) {
			def guaranteedShockBool = getBoolean("In the actual game introduction, when the lady goes over the predicament you're in, she demonstrates with a guaranteed shock. \n\n Since the game is all about random shocks, you have the option to disable it. \n\n If this is your first time playing, you should leave it enabled for atmosphere. You can always disable it later. \n\n Would you like to disable the initial shock?")
			if (guaranteedShockBool == true) { 
				guaranteedShock = 0 
				save("waitinggame.guaranteedShock", 0)
			}
			if (guaranteedShockBool == false) { 
				guaranteedShock = 1 
				save("waitinggame.guaranteedShock", 1)
			}
			menuRunning = false;
		}
		if(menu==2) {
			setImage("waitinggame/nintro4.jpg")
			show("This is Natasha Bell.")
			wait(6)
			setImage("waitinggame/vintro4.jpg")
			show("This is Veselin.")
			wait(6)
			def modelq = getSelectedValue ("Which mistress would you like?", ["Natasha", "Veselin"])
			if (modelq==0) {
				model = "n";
				save("waitinggame.model", "n");
			}
			if (modelq==1) {
				model = "v";
				save("waitinggame.model", "v");
			}
			menuRunning = false;
		}
		if(menu==3) {
			timerTemp = getSelectedValue( "Would you like the timer to be visible?",["Yes", "No"])
			if (timerTemp==0) {
				timeShow = true;
				save("waitinggame.timeshow", true)
				show("Timer will now be visible.")
				wait(3)
			}
				if (timerTemp==1) {
				timeShow = false;
				save("waitinggame.timeshow", false)
				show("Timer will now be visible.")
				wait(3)
			}
			menuRunning = false;
		}
	}
}

def infoMenu = {
	infoMenuVar = true;
	def shockString = "Yes";
	if (guaranteedShock) { shockString = "Yes" } 
	if (!guaranteedShock) { shockString = "No" }
	while (infoMenuVar) {
		def tempSessions = loadInteger("waitinggame.sessions");
		if (tempSessions == null) { tempSessions = 0; };
		def tempShocks = loadInteger("waitinggame.shocksGot"); 
		if (tempShocks == null) { tempShocks = 0; };
		def tempSecondsWaited = loadInteger("waitinggame.secondsWaited");
		if (tempSecondsWaited == null) { tempSecondsWaited = 0; };
		
		show("In total, you've:" 
		+ "\n\n received the shock " + tempShocks + " times."
		+ "\n spent " + (Math.round(tempSecondsWaited/60)) + " minutes waiting for the shock."
		
		+ "\n\n Settings:"
		+ "\n\n Time: " + runTime + " minutes."
		+ "\n Guaranteed shock: "	+ shockString)
		
		showButton("Back")
		infoMenuVar = false;
	}
}

def mainMenu = {
	def mainMenu = true;
	def tempSessions = loadInteger("waitinggame.sessions"); 
	while (mainMenu) {
	if (model == "v") { setImage("waitinggame/vintro3.jpg") }	
	if (model == "n") { setImage("waitinggame/nintro3.jpg") }	
	if (tempSessions == null)
	{
	menu = getSelectedValue	("Welcome to the Waiting Game, " + name + ". \n\n I can assure you it is much more exciting than the name.",["Tutorial & Start","Settings","Stats"])	
			if(menu==0) {
			waitingTutorial()
		}	
			if(menu==1) {
			settingsMenu()
		}
			if(menu==2) {
			infoMenu()
		}
	}
	else
	{
	menu = getSelectedValue	("Welcome to the Waiting Game, " + name + ". \n\n I can assure you it is much more exciting than the name.",["Quick Start","Tutorial & Start","Settings","Stats"])
			if(menu==0) {
			shockCheck()
			mainMenu = 0;
		}		
			if(menu==1) {
			waitingTutorial()
		}	
			if(menu==2) {
			settingsMenu()
		}
			if(menu==3) {
			infoMenu()
		}
	}
	}
}

mainMenu()

// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/

/*
 * Resources
 * scripts/waitinggame.groovy
 * images/waitinggame/*
 * sounds/waitinggame/gamepulse.wav
 * sounds/waitinggame/gamepulse_low.wav
 * sounds/waitinggame/gamepulse_long.wav
 * sounds/waitinggame/gamepulse_long_low.wav
*/

















